﻿Imports System
Imports System.Web
Imports System.Collections
Imports System.Collections.Generic
Imports System.Collections.Specialized
Imports System.Configuration
Imports System.Data
Imports System.Data.SqlClient
Imports System.Threading
Imports System.Web.Script.Services
Imports System.Web.Services
Imports System.Web.Services.Protocols
Imports Telerik.Web.UI


<ScriptService()> _
Public Class ProductCategories
    Inherits WebService
    <WebMethod()> _
    Public Function GetMenuCategories(ByVal item As RadMenuItemData, ByVal context As Object) As RadMenuItemData()
        Dim productCategories As DataTable = GetProductCategories(item.Value)

        Dim result As New List(Of RadMenuItemData)()

        For Each row As DataRow In productCategories.Rows
            Dim itemData As New RadMenuItemData()
            itemData.Text = row("Title").ToString()
            itemData.Value = row("CategoryId").ToString()

            If Convert.ToInt32(row("ChildrenCount")) > 0 Then
                itemData.ExpandMode = MenuItemExpandMode.WebService
            End If

            result.Add(itemData)
        Next

        Return result.ToArray()
    End Function

    <WebMethod()> _
    Public Function GetTreeViewCategories(ByVal node As RadTreeNodeData, ByVal context As Object) As RadTreeNodeData()
        Dim productCategories As DataTable = GetProductCategories(node.Value)

        Dim result As New List(Of RadTreeNodeData)()

        For Each row As DataRow In productCategories.Rows
            Dim itemData As New RadTreeNodeData()
            itemData.Text = row("Title").ToString()
            itemData.Value = row("CategoryId").ToString()

            If Convert.ToInt32(row("ChildrenCount")) > 0 Then
                itemData.ExpandMode = TreeNodeExpandMode.WebService
            End If

            result.Add(itemData)
        Next

        Return result.ToArray()
    End Function

    Private Function GetProductCategories(ByVal categoryId As Object) As DataTable
        Dim connection As New SqlConnection(ConfigurationManager.ConnectionStrings("TelerikConnectionString").ConnectionString)

        Dim selectCommand As New SqlCommand("" & Chr(13) & "" & Chr(10) & "" & Chr(9) & "SELECT" & Chr(13) & "" & Chr(10) & "" & Chr(9) & "" & Chr(9) & "pc1.CategoryID," & Chr(13) & "" & Chr(10) & "" & Chr(9) & "" & Chr(9) & "pc1.Title," & Chr(13) & "" & Chr(10) & "" & Chr(9) & "" & Chr(9) & "ISNULL(pc2.ChildrenCount, 0) as ChildrenCount" & Chr(13) & "" & Chr(10) & "" & Chr(9) & "FROM ProductCategories as pc1" & Chr(13) & "" & Chr(10) & "" & Chr(9) & "LEFT JOIN" & Chr(13) & "" & Chr(10) & "" & Chr(9) & "" & Chr(9) & "(" & Chr(13) & "" & Chr(10) & "" & Chr(9) & "" & Chr(9) & "" & Chr(9) & "SELECT   ParentId, COUNT(*) AS ChildrenCount" & Chr(13) & "" & Chr(10) & "" & Chr(9) & "" & Chr(9) & "" & Chr(9) & "FROM     ProductCategories" & Chr(13) & "" & Chr(10) & "" & Chr(9) & "" & Chr(9) & "" & Chr(9) & "Group By (ParentId)" & Chr(13) & "" & Chr(10) & "" & Chr(9) & "" & Chr(9) & ") as pc2" & Chr(13) & "" & Chr(10) & "" & Chr(9) & "ON" & Chr(13) & "" & Chr(10) & "" & Chr(9) & "" & Chr(9) & "pc1.CategoryId = pc2.ParentId" & Chr(13) & "" & Chr(10) & "" & Chr(9) & "WHERE pc1.parentId = @parentId" & Chr(13) & "" & Chr(10) & "", connection)

        selectCommand.Parameters.AddWithValue("parentId", categoryId)

        Dim adapter As New SqlDataAdapter(selectCommand)



        Dim productCategories As New DataTable()
        adapter.Fill(productCategories)

        Return productCategories
    End Function
End Class
